\renewcommand{\FIGREP}{src/build_tools/figures}

\section{Build automation tools}
\label{sec:build_tools}
\intersec{fidis}

\subsection{GNU Make}
\label{sec:gnu-make}
\begin{frame}[t,fragile]
  \frametitle{Build automation tool}
  \framesubtitle{GNU Make}
  \begin{itemize}
    \item Compiling one file by hand is fine, but multiple files become quickly
          cumbersome
    \item Tools have been developed to automatize such process
    \item Here, we will only briefly introduce GNU Make and CMake
  \end{itemize}

  \vfill

  \textbf{GNU Make aka Makefile:}
  \begin{itemize}
    \item The command line \cmd{make} executes shell commands contained in a
          Makefile (list of rules)
    \item Rules contain three components:
          \begin{bashcode}
            target: prerequisites
            ->|     recipe
            ->|     ...
          \end{bashcode}
    \item Make keeps track of timestamps: it updates only targets that are
          required
    \item Make can be used for a lot of other things than compiling code!
    \item Just type \cmd{make} in the folder containing the \cmd{Makefile} file
  \end{itemize}
\end{frame}
\note{
  \begin{itemize}
    \item If you have a large program with many source and/or header files, when you change a file on which others depend, you must recompile all the dependent files. Without a Makefile, this is an extremely time-consuming task.
    \item The Makefile contains a list of rules. These rules tell the system what commands you want to be executed. Most times, these rules are commands to compile(or recompile) a series of files. The rules, which must begin in column 1, are in two parts. The first line is called a dependency line and the subsequent line(s) are called actions or commands. The action line(s) must be indented with a tab.
    \item CMake is used to control the software compilation process using simple platform and compiler independent configuration files, and generate native Makefiles and workspaces that can be used in the compiler environment of your choice
  \end{itemize}
}

\begin{frame}[t,fragile]
  \frametitle{Makefile}
  \framesubtitle{First naive example}
  \makefile[title={examples/compilation\_with\_makefile/Makefile}]{examples/compilation_with_makefile/Makefile}
\end{frame}
\note{
  \begin{itemize}
    \item First, we can use in the Makefile some variables to assign commands
    \item On the left you have the so-called target: all, ... and following the target, the dependencies %my_exec, etc ... and following the target: the dependencies
    \item The recipes are introduced below the definition target:dependencies
    \item A target might be a binary file that depends on dependencies (source files). On the other hand, a dependency can also be a target that depends on other dependencies:
  \end{itemize}
}

\begin{frame}[t,fragile]
  \frametitle{Makefile}
  \framesubtitle{More refined example}
  \makefile[title={examples/compilation\_with\_makefile\_advanced/Makefile}]{examples/compilation_with_makefile_advanced/.makefile}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Makefile}
  \framesubtitle{More refined example}
  \makefile[title={examples/compilation\_with\_makefile\_advanced/Makefile}]{examples/compilation_with_makefile_advanced/Makefile}
\end{frame}

\subsection{CMake}
\label{sec:cmake}
\begin{frame}[t,fragile]
  \frametitle{Build automation tool}
  \framesubtitle{CMake}

  \textbf{CMake:}
  \begin{itemize}
    \item CMake is an abstraction level above Make and other build systems
    \item It automatically detects compilers and libraries and generate a
          Makefile (or other tools, \eg{} Ninja)
    \item Suggested workflow:
          \begin{itemize}
            \item Configure the project
                  \begin{bashcode}
                    cmake -S . -B build
                  \end{bashcode}
            \item Compile it
                  \begin{bashcode}
                    cmake --build build
                  \end{bashcode}
          \end{itemize}
  \end{itemize}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{CMake}
  \framesubtitle{Configuration output}

  \begin{consoleoutput}
    $ cmake -S . -B build
    -- The C compiler identification is GNU 8.4.0
    -- Check for working C compiler: /ssoft/.../gcc-4.8.5/gcc-8.4.0/bin/gcc
    -- Check for working C compiler: /ssoft/.../gcc-4.8.5/gcc-8.4.0/bin/gcc -- works
    -- Detecting C compiler ABI info
    -- Detecting C compiler ABI info - done
    -- Detecting C compile features
    -- Detecting C compile features - done
    -- Configuring done
    -- Generating done
    -- Build files have been written to: compilation_with_cmake/build
  \end{consoleoutput}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{CMake example}
  \framesubtitle{}
  \cmakefile[title={examples/compilation\_with\_cmake/CMakeLists.txt}]{examples/compilation_with_cmake/CMakeLists.txt}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Compilation}
  \framesubtitle{CMake example}
  \cmakefile[title={examples/compilation\_with\_cmake\_openblas/CMakeLists.txt}]{examples/compilation_with_cmake_openblas/CMakeLists.txt}
\end{frame}

\begin{frame}[exercise]
  \frametitle{Compilation}
  \framesubtitle{Exercise compilationWithCmakeAdvanced}
  \begin{itemize}
    \item Go to the directory \cmd{compilation_with_cmake}
    \item Compile the code, first with \cmd{gcc} compiler in \cmd{build_gcc}
          \begin{itemize}
            \item load the proper modules \cmd{gcc} and \cmd{openblas}
            \item configure \cmd{cmake -S . -B build_gcc}
            \item compile \cmd{cmake --build build_gcc}
          \end{itemize}
    \item Compile the code, in \cmd{build_intel} with \cmd{intel} compiler
  \end{itemize}
\end{frame}

%%% Local Variables:
%%% mode: latex
%%% TeX-master: "../../SCM_slides"
%%% TeX-command-extra-options: "-shell-escape"
%%% End:
